#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  int n, i, size, rank;
  double pi;
  MPI_Status status;

  MPI_Init (&argc, &argv);
  MPI_Comm_size (MPI_COMM_WORLD, &size);
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);

  if (argc != 2)
    n = 10;
  else
    n = atoi(argv[1]);

  pi = 0.0;

  for (i=rank+1; i<=n; i+=size) {
    pi += (double) i;
  }

  if (rank != 0) {
    MPI_Send (&pi, 1, MPI_DOUBLE, 0, 1, MPI_COMM_WORLD);
  }
  else {
    double temp;

    for (i = 1; i <= size-1; i++) {
      MPI_Recv (&temp, 1, MPI_DOUBLE, i, 1, MPI_COMM_WORLD, &status);
      pi += temp;
    }
  }

  if (rank == 0) {
    fprintf ( stdout, "computed pi value = %.23f...\n", pi);
  }

  MPI_Finalize ();
 
  return 0;
} 
